function batchSize_plot

M = 1000; % sample size
B = 1:M;

rho  = (M - B)./M;
bnd1 = 4*rho.^2;
bnd2 = rho*(M/(M-1))./B;

options.logScale = 2;
options.xlabel = 'Batch size';
options.ylabel = 'Bounding factor';
options.legendStr = {'Deterministic','Expected'};
options.colors = {  [1.000   0.750   0.500],
                    [0.500   0.500   0.500] };
options.lineStyles = {'-','--'};
prettyPlot3(B, {bnd1, bnd2}, options);
ylim([0 1.1*max(bnd1)]);
print('-dpdf', 'plots/batchSize_plot.pdf');
end

