function expBatching_plot(loss,maxIter,zoom,doStochastic1,...
                          stepSizeValues1,doHybridWolfe)
close all

if nargin < 3
	zoom = 1; % Fraction of longest run to truncate x-axis to
end
if nargin < 4
	doStochastic1 = 0; % Include stochastic method
end
if nargin < 5
	stepSizeValues1 = 10.^[-3:2];
end
if nargin < 6
	doHybridWolfe = 0;
end

% Decide whether to run differnet methods
doDeterministic = 1;
doStochastic2 = 0;
doHybrid = 1;
doHybrid2 = 0;
doMultipleParams = 0;

if doHybrid2
	doHybrid1 = 0;
end

% Parameters
deltaValues = 1;
gammaValues = 1.1;
stepSizeValues2 = 10.^[-5:4];

% Data Sets
dataSets = cell(0,1);
stepSizes = cell(0,1);
switch loss
	case {'logreg'}
		%dataSets{end+1,1} = 'sido';
		%dataSets{end+1,1} = 'thrombin';
		dataSets{end+1,1} = 'spam';
		%dataSets{end+1,1} = 'rcv1';
		%dataSets{end+1,1} = 'real-sim';
		%dataSets{end+1,1} = 'news';
		%dataSets{end+1,1} = 'rcv12';
	case {'logregl2'}
		dataSets{end+1,1} = 'spam';
		%dataSets{end+1,1} = 'rcv12';
	case {'mlogreg'}
		%dataSets{end+1,1} = 'wave';
		%dataSets{end+1,1} = 'shuttle';
		%dataSets{end+1,1} = 'usps';
		%dataSets{end+1,1} = 'mnist16';
		dataSets{end+1,1} = 'mnist';
		%dataSets{end+1,1} = 'rcv1';
	case 'crf'
		dataSets{end+1,1} = 'coNLL';
		%dataSets{end+1,1} = 'coNLL2';
	case {'crf2d','crf2d_trbp'}
		%dataSets{end+1,1} = 'noisyX';
		%dataSets{end+1,1} = 'usps';
		%dataSets{end+1,1} = 'mnist';
		dataSets{end+1,1} = 'kumar';
	case 'dwi'
		dataSets{end+1,1} = 'tristan';
		gammaValues = 1;
end

for d = 1:length(dataSets)
	
	
	if d > 1
		pause
		figure(1);clf;
		figure(2);clf;
	end
	
	data = dataSets{d}
	
	%%
	fVals = cell(0,1);
	rfVals = cell(0,1);
	fEvals = cell(0,1);
	bSizes = cell(0,1);
	optConds = cell(0,1);
	names = cell(0,1);
	colors = zeros(0,3);
	markers = cell(0,1);
	param2 = 0;
	param3 = 0;
	
	if doStochastic1
		method = 'sgd1';
		dim = 1;
		for stepSize = stepSizeValues1
			param1 = stepSize;
			if strcmp(loss,'dwi') && maxIter == 150 && zoom == 2/3
				mxIter = 100; % Don't have 150 iteration results for all data, so just use 100 iteration version
			else
				mxIter = maxIter;
			end
			resultFile = sprintf('batching/results/%s/%s_%s_%d_%e_%e_%e.mat',loss,data,method,mxIter,param1,param2,param3);
			resultFile = fixResultFile(resultFile);
			load(resultFile);
			fVals{end+1,1} = fVal;
			fEvals{end+1,1} = fEval;
			bSizes{end+1,1} = repmat(1,length(fEval),1);
			names{end+1,1} = sprintf('Stochastic1(%.e)',stepSize);
			if 1
				colors(end+1,:) = dim*[0 1 0];
				dim = dim*(1/2);
			else
				colors(end+1,:) = [rand rand rand];
			end
			markers{end+1} = [];
			if mxIter ~= 100
				optConds{end+1,1} = optCond;
			end
		end
	end
	
	if doStochastic2
		method = 'sgd2';
		for stepSize = stepSizeValues2
			param1 = stepSize;
			resultFile = sprintf('batching/results/%s/%s_%s_%d_%e_%e_%e.mat',loss,data,method,maxIter,param1,param2,param3);
			resultFile = fixResultFile(resultFile);
			load(resultFile);
			fVals{end+1,1} = runningMin(fVal);
			fEvals{end+1,1} = fEval;
			names{end+1,1} = sprintf('Stochastic2(%.e)',stepSize);
			if 0
				colors(end+1,:) = [0 .5 0];
			else
				colors(end+1,:) = [rand rand rand];
			end
			markers{end+1} = [];
		end
	end
	
	if doHybrid
		clear batchSizes
		method = 'batching';
		for gamma = gammaValues
			for delta = deltaValues
				if delta == 0 && gamma == 1
					continue
				end
				param1 = 1e-8;
				param2 = gamma;
				param3 = delta;
				resultFile = sprintf('batching/results/%s/%s_%s_%d_%e_%e_%e.mat',loss,data,method,maxIter,param1,param2,param3);
				resultFile = fixResultFile(resultFile);
				load(resultFile);
				fVals{end+1,1} = fVal;
				fEvals{end+1,1} = fEval;
				bSizes{end+1,1} = batchSizes;
				if doMultipleParams
					names{end+1,1} = sprintf('Hybrid (gamma = %f, delta = %f',gamma,delta);
					colors(end+1,:) = [rand rand rand];
				else
					names{end+1,1} = sprintf('Hybrid',gamma,delta);
					colors(end+1,:) = [1 0 0];
				end
				markers{end+1} = 'x';
				if maxIter ~= 100
					optConds{end+1,1} = optCond;
				end
			end
		end
	end
	
	if doHybrid2
		clear batchSizes
		method = 'batching2';
		dim = 1;
		for scaleObj = 1 %[0 1]
			for scaleStep = 1%[0 1 2]
				param1 = 1e-8;
				param2 = scaleStep;
				param3 = scaleObj;
				resultFile = sprintf('batching/results/%s/%s_%s_%d_%e_%e_%e.mat',loss,data,method,maxIter,param1,param2,param3);
				resultFile = fixResultFile(resultFile);
				load(resultFile);
				fVals{end+1,1} = fVal;
				fEvals{end+1,1} = fEval;
				bSizes{end+1,1} = batchSizes;
				if 0
					names{end+1,1} = sprintf('Hybrid (scaleStep = %f, scaleObj = %f',param2,param3);
					colors(end+1,:) = [rand rand rand];
				else
					names{end+1,1} = sprintf('Hybrid (scaleStep = %f, scaleObj = %f',param2,param3);
					colors(end+1,:) = dim*[0 1 0];
					dim = dim*(1/2);
				end
				markers{end+1} = 'x';
			end
		end
	end
	
	if doHybridWolfe
		clear batchSizes
		method = 'batchingWolfe';
		for gamma = gammaValues
			for delta = deltaValues
				if delta == 0 && gamma == 1
					continue
				end
				param1 = 1e-5;
				param2 = gamma;
				param3 = delta;
				resultFile = sprintf('batching/results/%s/%s_%s_%d_%e_%e_%e.mat',loss,data,method,maxIter,param1,param2,param3);
				resultFile = fixResultFile(resultFile);
				load(resultFile);
				fVals{end+1,1} = fVal;
				fEvals{end+1,1} = fEval;
				bSizes{end+1,1} = batchSizes;
				if doMultipleParams
					names{end+1,1} = sprintf('Hybrid (gamma = %f, delta = %f',gamma,delta);
					colors(end+1,:) = [rand rand rand];
				else
					names{end+1,1} = sprintf('Hybrid-Wolfe',gamma,delta);
					colors(end+1,:) = .5*[1 0 0];
				end
				markers{end+1} = 'x';
				if maxIter ~= 100
					optConds{end+1,1} = optCond;
				end
			end
		end
	end
	
	if doDeterministic
		method = 'lbfgs';
		param1 = 0;
		param2 = 0;
		param3 = 0;
		resultFile = sprintf('batching/results/%s/%s_%s_%d_%e_%e_%e.mat',loss,data,method,maxIter,param1,param2,param3);
		resultFile = fixResultFile(resultFile);
		load(resultFile);
		ymax = fVal(1);
		fVals{end+1,1} = fVal;
		fEvals{end+1,1} = fEval;
		bSizes{end+1,1} = repmat(nInstances,length(fEval),1);
		names{end+1,1} = 'Deterministic';
		colors(end+1,:) = [0 0 1];
		markers{end+1} = 'o';
		if maxIter ~= 100
			optConds{end+1,1} = optCond;
			maxOpt = optCond(1);
		end
	end
	
	maxEval = 0;
	minEval = inf;
	for n = 1:length(names)
		fEvals{n,1} = fEvals{n,1}/nInstances; % Normalize evaluations by size of data set
		bSizes{n,1} = bSizes{n,1}/nInstances; % Normalize batch sizes by size of data sets
		if max(fEvals{n,1}) > maxEval
			maxEval = max(fEvals{n,1});
		end
		if max(fEvals{n,1}) < minEval
			minEval = max(fEvals{n,1});
		end
	end
	
	minVal = inf;
	minVal2 = inf;
	for n = 1:length(names)
		if min(fVals{n,1}) < minVal;
			minVal = min(fVals{n,1});
			if maxIter ~= 100
				if n < length(optConds)
					minOpt = min(optConds{n,1});
				end
			end
        end
		if min(fVals{n,1}(fEvals{n,1} < maxEval*zoom)) < minVal2
			minVal2 = min(fVals{n,1}(fEvals{n,1} < maxEval*zoom));
		end
	end
	for n = 1:length(names)
		rfVals{n,1} = fVals{n,1}-minVal;
	end
	
	options.legendLoc = 'NorthEast';
	options.logScale = 0;
	options.colors = colors;
	options.markers = markers;
	options.markerSize = 6;
	options.legendStr = names;
	options.xlabel = 'Passes through data';
	options.ylabel = 'Objective';
	%options.plottitle = data;
	figure(1);
	prettyPlot3(fEvals,fVals,options);
	if zoom
		xlim([0 maxEval*zoom]);
		ylim([minVal2 ymax+1e-4]);
	else
		xlim([0 minEval]);
		ylim([minVal ymax+1e-4]);
	end
	if 0
	if doStochastic1
		print('-dpdf',['plots/' sprintf('%s_%s_stochastic.pdf',loss,data)]);
	else
		print('-dpdf',['plots/' sprintf('%s_%s.pdf',loss,data)]);
	end
	end
	
	figure(2);
	options.logScale = 2;
	options.ylabel = 'Objective minus Optimal';
	prettyPlot3(fEvals,rfVals,options);
	xlim([0 minEval]);
	if zoom
		xlim([0 maxEval*zoom]);
		yl = ylim;
		ylim([minVal2-minVal ymax-minVal+1e-4]);
	else
		xlim([0 minEval]);
	end
	if doStochastic1
		print('-dpdf',['plots/' sprintf('%s_%s_stochastic_log.pdf',loss,data)]);
	else
		print('-dpdf',['plots/' sprintf('%s_%s_log.pdf',loss,data)]);
	end
	
	figure(3);clf;
	options.logScale = 0;
	options.ylabel = 'Batch Size';
	if 1
		% Plot batch size vs. evaluation
		prettyPlot3(fEvals,bSizes,options);
	else
		% Plot batch size vs. iteration
		options.xlabel = 'iteration';
		prettyPlot3([],bSizes,options);
	end
	
	if zoom
		xlim([0 maxEval*zoom]);
	else
		xlim([0 minEval]);
	end
	if 0
	if doStochastic1
		print('-dpdf',['plots/' sprintf('%s_%s_stochastic_batch.pdf',loss,data)]);
	else
		print('-dpdf',['plots/' sprintf('%s_%s_batch.pdf',loss,data)]);
	end
	end
	
	if 0
		figure(4);
		options.logScale = 2;
		options.xlabel = 'Passes through data';
		options.ylabel = 'Infinity Norm of Gradient\n';
		prettyPlot3(fEvals,optConds,options);
		xlim([0 maxEval*zoom]);
		ylim([minOpt maxOpt+1e-4]);
		print('-dpdf',['plots/' sprintf('%s_%s_gradient.pdf',loss,data)]);
	end
 
    figure(4);
    options.logScale = 0;
    options.xlabel = 'Iterations';
    options.ylabel = 'Cumulative samples evaluated';
    options.colors = options.colors(4:5,:);
    options.markers = [];
    options.legendStr = options.legendStr(4:5);
    cc4 = fEvals{4}*nInstances;
    cc5 = fEvals{5}*nInstances;
    xcount = {1:length(cc4)
              1:length(cc5)};
    prettyPlot3(xcount,{cc4,cc5},options);
    xlim([0 max(xcount{1}(end),xcount{2}(end))]);
    ylim([0 max(cc4(end),cc5(end))])
    print('-dpdf',['plots/' sprintf('%s_%s_cumulative.pdf',loss,data)]);
%   fprintf('(paused)\n');
%   pause
end
