function [] = expBatching_run(loss,maxIter,doStochastic1,stepSizeValues1,doHybridWolfe)
% loss can be 'logreg', 'logregl2', or 'crf'

if nargin < 3
	doStochastic1 = 0;
end
if nargin < 4
	stepSizeValues1 = 10.^[-3:2];
end
if nargin < 5
	doHybridWolfe = 0;
end

% Decide whether to run differnet methods
doDeterministic = 1;
doHybrid = 1;
doHybrid2 = 0;
doStochastic2 = 0;
stepSizeValues2 = 10.^[-5:4];

deltaValues = 1;
gammaValues = 1.1;

% Data Sets
dataSets = cell(0,1);
switch loss
	case {'logreg','logregl2'}
		%dataSets{end+1,1} = 'sido';
		%dataSets{end+1,1} = 'thrombin';
		dataSets{end+1,1} = 'spam';
		%dataSets{end+1,1} = 'rcv1';
		%dataSets{end+1,1} = 'real-sim';
		%dataSets{end+1,1} = 'news';
		%dataSets{end+1,1} = 'rcv12';
	case {'mlogreg'}
		%dataSets{end+1,1} = 'wave';
		%dataSets{end+1,1} = 'shuttle';
		%dataSets{end+1,1} = 'usps';
		%dataSets{end+1,1} = 'mnist16';
		dataSets{end+1,1} = 'mnist';
		%dataSets{end+1,1} = 'rcv1';
		%dataSets{end+1,1} = 'rcv12';
	case 'crf'
		dataSets{end+1,1} = 'coNLL';
		%dataSets{end+1,1} = 'coNLL2';
	case {'crf2d','crf2d_trbp'}
		%dataSets{end+1,1} = 'noisyX';
		%dataSets{end+1,1} = 'usps';
		dataSets{end+1,1} = 'kumar';
	case 'dwi'
		dataSets = {'tristan'};
		gammaValues = 1;
end

if doDeterministic
	for d = 1:length(dataSets)
		data = dataSets{d};
		
		expBatching(loss,data,'lbfgs',maxIter,0,0,0);
	end
end

for d = 1:length(dataSets)
	data = dataSets{d};
	if doHybrid
		stepSize = 1e-8;
		for gamma = gammaValues
			for delta = deltaValues
				if delta == 0 && gamma == 1
					continue
				end
				expBatching(loss,data,'batching',maxIter,stepSize,gamma,delta);
			end
		end
	end
	if doHybrid2
		stepSize = 1e-8;
		for scaleObj = [0 1]
			for scaleStep = [0 1 2]
				expBatching(loss,data,'batching2',maxIter,stepSize,scaleStep,scaleObj);
			end
		end
	end
	if doHybridWolfe
		stepSize = 1e-4;
		for gamma = gammaValues
			for delta = deltaValues
				if delta == 0 && gamma == 1
					continue
				end
				expBatching(loss,data,'batchingWolfe',maxIter,stepSize,gamma,delta);
			end
		end
	end
end



if doStochastic1
	for d = 1:length(dataSets)
		data = dataSets{d};
		for stepSize = stepSizeValues1
			expBatching(loss,data,'sgd1',maxIter,stepSize,0,0);
		end
	end
end
if doStochastic2
	for d = 1:length(dataSets)
		data = dataSets{d};
		for stepSize = stepSizeValues2
			expBatching(loss,data,'sgd2',maxIter,stepSize,0,0);
		end
	end
end
