function [] = expBatching_showCRF2Dimages(data,method,maxIter)

close all

randn('state',0);
rand('state',0);

if ~exist('batching/results/crf2d_images','dir')
	mkdir('batching/results/crf2d_images');
end

switch method
	case 'lbfgs'
	param1 = 0;
	param2 = 0;
	param3 = 0;
	case 'batching';
	param1 = 1e-8;
	param2 = 1.1;
	param3 = 1;
	case 'sgd1'
		param1 = 1e-4;
		param2 = 0;
		param3 = 0;
end

loss = 'crf2d';
switch data
	case 'noisyX'
		[Xnode,Xedge,Y,edgeStruct,infoStruct] = prepareNoisyX(100);
		nRows = 32;
		nCols = 32;
		invert = 0;
	case 'usps'
		[Xnode,Xedge,Y,edgeStruct,infoStruct] = prepareNoisyUSPS;
		nRows = 16;
		nCols = 16;
		invert = 1;
	case 'mnist'
		[Xnode,Xedge,Y,edgeStruct,infoStruct] = prepareNoisyMNIST;
		nRows = 28;
		nCols = 28;
		invert = 2;
	case 'kumar'
		[Xnode,Xedge,Y,edgeStruct,nodeMap,edgeMap,nRows,nCols] = prepareBinaryDenoising;
		nRows = 64;
		nCols = 64;
		invert = 1;
end
nInstances = size(Y,1);

resultDir = sprintf('batching/results/%s',loss);
resultFile = sprintf('%s/%s_%s_%d_%e_%e_%e.mat',resultDir,data,method,maxIter,param1,param2,param3);
resultFile = fixResultFile(resultFile);
load(resultFile);
fprintf('Showing images for %s with maxIter = %d\n',method,maxIter);
for i = 12
    [nodePot,edgePot] = UGM_CRF_makePotentials(w,Xnode,Xedge,nodeMap,edgeMap,edgeStruct,i);
	figure(1);
	colormap gray
	if invert ==2
		imshow(-reshape(Y(i,:),nRows,nCols)',[]);
	elseif invert
		imshow(-reshape(Y(i,:),nRows,nCols),[]);
	else
		imshow(reshape(Y(i,:),nRows,nCols),[]);
	end
	print('-dpdf',sprintf('plots/crf2d_images_%s_%d_true.pdf',data,i));
	figure(2);
	colormap gray
	if invert ==2
		imshow(-reshape(Xnode(i,2,:),nRows,nCols)',[]);
	elseif invert
		imshow(-reshape(Xnode(i,2,:),nRows,nCols),[]);
	else
		imshow(reshape(Xnode(i,2,:),nRows,nCols),[]);
	end
	print('-dpdf',sprintf('plots/crf2d_images_%s_%d.pdf',data,i));
	nodeBel = UGM_Infer_LBP(nodePot,edgePot,edgeStruct);
	figure(3);
	colormap gray
	if invert==2
		imshow(-reshape(nodeBel(:,2),nRows,nCols)',[]);
	elseif invert
		imshow(-reshape(nodeBel(:,2),nRows,nCols),[]);
	else
		imshow(reshape(nodeBel(:,2),nRows,nCols),[]);
	end
	print('-dpdf',sprintf('plots/crf2d_images_%s_%d_%s_%d.pdf',data,i,method,maxIter));
end
%fprintf('(paused)\n');
%pause
