function output = Src(model)
% output = Src(model)
%
% fill source matrix
% S = exp(-(r/model.sigma)^2)
% where
% r = sqrt((x-xs)^2 + (z-zs)^2)
%

x = model.x; nx = length(x); dx = x(2)-x(1);
z = model.z; nz = length(z); dz = z(2)-z(1);
[xx,zz] = meshgrid(x,z);
[xs,zs] = meshgrid(model.xsrc,model.zsrc);
nsrc = length(zs(:));
output = zeros(nx*nz,nsrc);

for k = 1:nsrc
    r = (xx-xs(k)).^2 + (zz-zs(k)).^2;
    output(:,k) = exp(-r(:)/model.sigma^2);
end
